2 # Desc: Template to report seconds until beginning of next day
3 # Author: Steven Baltaktei Sandoval; License: GPLv3+
5 #==BEGIN Define script parameters==
6 #===BEGIN Declare local script functions===
7 yell
() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
8 die
() { yell
"$*"; exit 111; }
9 try
() { "$@" || die
"cannot $*"; }
11 # Desc: Report seconds until next day.
12 # Output: stdout: integer seconds until next day
13 # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
14 # Usage: timeUntilNextDay
15 # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
17 TIME_CURRENT
="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
18 TIME_CURRENT_SHORT
="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)" # Produce separator-less current timestamp with resolution 1 second.
19 DATE_CURRENT
="$(date -d "$TIME_CURRENT" --iso-8601=date)" ; # Produce `date`-parsable current timestamp with resolution of 1 day.
20 DATE_CURRENT_SHORT
="$(date -d "$TIME_CURRENT" +%Y%m%d)" ; # Produce separator-less current timestamp with resolution 1 day.
21 DATE_TOMORROW
="$(date -d "$TIME_CURRENT next day
" --iso-8601=date)" ; # Produce timestamp of tomorrow's date (res. 1 day).
22 TIME_NEXT_DAY
="$(date -d "$DATE_TOMORROW" --iso-8601=seconds)" ; # Produce `date`-parsable timestamp of closest next day (res. 1 second).
23 SECONDS_UNTIL_NEXT_DAY
="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
24 if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then
26 elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then
27 returnState
="WARNING_ZERO";
28 yell
"WARNING:Reported time until next day exactly zero.";
29 elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then
30 returnState
="WARNING_NEGATIVE";
31 yell
"WARNING:Reported time until next day is negative.";
34 try
echo "$SECONDS_UNTIL_NEXT_DAY"; # Report
36 #===Determine function return code===
37 if [[ "$returnState" = "true" ]]; then
39 elif [[ "$returnState" = "WARNING_ZERO" ]]; then
41 elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
44 } # Report seconds until next midnight
45 #===END Declare local script functions===
46 #==END Define script parameters==
49 #==BEGIN sample code==
50 try
echo "Time until next day (seconds):$(timeUntilNextDay)" # simple report
52 if ! myTTL
="$(timeUntilNextDay)"; then yell
"ERROR in if statement for myTTL:$myTTL"; exit 1; fi # Use of exit code to exit early if time <= 0.